# Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved. 
import WebCenterWLSTHelper as wlsthelper
wlsthelper.loadHandler('WebCenterWLSTHelper')
wlsthelper.loadHandler('WebCenterHandlerHelper')

def deleteConnection(appName,name,server='',applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    helper.deleteConnection(appName,name,server,applicationVersion)
    webcenterRestore(origDirectory)

def webcenterConnectionExists(appName,name,server='',applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    result = helper.customGetConnectionExists(appName,name,server,applicationVersion)
    webcenterRestore(origDirectory)
    return result

def webcenterConnectionExistsType(appName,name,type,server='',applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    result = helper.customGetConnectionByType(appName,name,type,server,applicationVersion)
    webcenterRestore(origDirectory)
    return result

def checkWebCenterAppState(appName,server,applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    result = helper.checkWebCenterAppState(appName,server,applicationVersion)
    webcenterRestore(origDirectory)
    return result

def getWebCenterConnectionTypes(appName,server='',applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    result = helper.customGetConnectionTypes(appName,server,applicationVersion)
    webcenterRestore(origDirectory)
    return result

def getWebCenterConnectionNamesByType(appName,type,server='',applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    result = helper.customGetConnectionNamesByType(appName,type,server,applicationVersion)
    webcenterRestore(origDirectory)
    return result

def doesADFConfigObjExist(appName,server='',applicationVersion=''):
    origDirectory = webcenterInitialize(server,applicationVersion)
    if webcenterErrorOccurred():
	return 0 
    result =  helper.doesADFConfigObjExist(appName)
    webcenterRestore(origDirectory)
    return result 

# These commands do not need webcenterInitialize and webcenterRestore because they are only setting /getting WebCenter constants
def webcenterGetRaiseScriptingException():
    return helper.webcenterGetRaiseScriptingException()

def webcenterSetRaiseScriptingException(raiseException):
    helper.webcenterSetRaiseScriptingException(raiseException)

def webcenterErrorOccurred():
    return helper.webcenterErrorOccurred()

def webcenterPingHost(host, port):
    return wlsthelper.pingHost((host, port))

def webcenterIsConnected():
    if connected == 'false':
        return 0
    return 1 

