# Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved. 
from java.lang import System
from java.lang import Exception
import os
import socket
import sys
import ora_mbs
import wlstModule as webcenter_wlst
import ora_util

def loadHandler(handlerName):
    oh = System.getProperty('ORACLE_HOME')
    if oh is not None:
        sh = os.path.join(oh, os.path.join('common', 'script_handlers'))
        if sh not in sys.path:
            sys.path.append(sh)
    for path in sys.path:
         py = os.path.join(path, handlerName + '.py')
         if os.path.exists(py):
             execfile(py)
             break

def pingHost(sa):
   s = None
   try:
       s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
   except socket.error, msg:
       s = None
   try:
       s.connect(sa)
   except socket.error, msg:
       s.close()
       s = None
   if s is None:
       return 0
   else:
       s.close()
       return 1

loadHandler('WebCenterHandlerHelper')
import WebCenterHandlerHelper as helper

def webcenterNoOpDisplayHook(dummy):
    pass

def webcenterHideDisplayReturnValue():
    global oldhook
    oldhook=sys.displayhook
    sys.displayhook = webcenterNoOpDisplayHook
    
def webcenterRestoreDisplay():
    global oldhook,myps1
    sys.displayhook=oldhook
    myps1=sys.ps1
    

# Initialize the context for WebCenter commands
# Returns the user's directory if initialization is successful. Returns the null object if initialization fails.
def webcenterInitialize(server='',applicationVersion=''):
    origDirectory = webcenter_wlst.pwd()
    domainRuntime()
    ora_mbs.setMbs(mbs)
    if ora_mbs.isConnected()==0:
        helper.wcPrintErrorMessage('PLEASE_CONNECT_WLS')
        return None
    webcenterHideDisplayReturnValue()
    helper.webcenterInitialize(server, applicationVersion)
    return origDirectory

# Restore the user context. If origDirectory is null because of failed initalization, does nothing
def webcenterRestore(origDirectory):
    if origDirectory is None:
        return    
    webcenter_wlst.cd(origDirectory)
    webcenterRestoreDisplay()
    helper.webcenterRestore()
    if helper.webcenterGetRaiseScriptingException():
	helper.webcenterCommandError()
        helper.webcenterRaiseException()

#Sets Webcenter Global Error Code
def webcenterCommandError():
    helper.webcenterCommandError()
