/* $Header: workplace/src/apps/webcenter-app/spaces-web/src/javascripts/oracle/webcenter/webcenterapp/jsLibs/WebCenterTabPopup.js /main/16 2010/07/19 08:58:59 akatti Exp $ */

/* Copyright (c) 2006, 2010, Oracle and/or its affiliates. 
All rights reserved. */

/*
   DESCRIPTION
    Contains javascript utility methods for common operations
    for the WebCenterTab popup actions.

   NOTES
    <other useful comments, qualifications, etc.>

   MODIFIED    (MM/DD/YY)
      akatti    06/28/10 - safe-guard tab for nullness wcOnRenderNavPaneTimeout
      anjbaner  05/28/09 - XbranchMerge anjbaner_rc4to5shellfixes2k9may from
                           st_workplace_11.1.1.1.0
      anjbaner  05/18/09 - taking out print preview method as we now use faces
                           show-printable-page-behavior
      aduggad   02/02/09 - XbranchMerge aduggad_jan27_customize_shell_config
                           from main
      dhayler   01/16/09 - XbranchMerge dhayler_bug-7588096 from main
      dhayler   01/15/09 - Add print preview qs arg.
      anjbaner  09/24/08 - expanding to allow ctx menu on hover
      aduggad   09/10/08 - 
      anjbaner  07/03/08 - splitting up the popup showing method into two since
                           the popup can be lazy
      anjbaner  11/30/07 - taking subview into account
      sfrankli  11/18/07 - 
      anjbaner  09/18/07 - fixing ctx menu in ie
      anjbaner  08/03/07 - preventing deletion if shared page
      anjbaner  06/15/07 - postponing tab title change logic
 */


  var WCPopupLagData = new Object();
  WCPopupLagData.TABCLIENTID = 0;
  WCPopupLagData.TABALLOWEDOPS = 0;
  WCPopupLagData.TAB_DESTINATION;
  WCPopupLagData.TAB_LABEL;
  WCPopupLagData.TAB_LEVEL;

  var showTabTooltip = true;
  var tabTooltipTimeoutId;

function wcOnRenderNavigationPane(navPaneId, selectedTabIndex)
{
  window.setTimeout('wcOnRenderNavPaneTimeout("' + navPaneId + '", ' 
                      + selectedTabIndex + ');', 100);
}

function wcOnRenderNavPaneTimeout(navPaneId, selectedTabIndex)
{
  var navPane = AdfPage.PAGE.findComponent(navPaneId);
  if (selectedTabIndex >= 0)
  {
    var tab = navPane.findComponent('' + selectedTabIndex + ':tab');
    if (tab != null && tab.getProperty('wcAllowedOperationsNonEmpty') == true)
      _wcActivateTabPopupLauncher(tab);
  }
}

function _wcActivateTabPopupLauncher(tab)
{
  // making the tab dropdown icon visible and associatiing with tab
  var navPane = tab.getParent();
  var popupIconicLauncher = navPane.findComponent('tabPopUp:tabPopupLauncher');
  popupIconicLauncher.setProperty('wcTabClientId', tab.getClientId());
  popupIconicLauncher.setVisible(true);

  // workaround to make sure that the component really got prepared on client
  popupIconicLauncher.setVisible(false);
  popupIconicLauncher.setVisible(true);

  // getDomElement() doesn't return anything 
  // until all Faces onload processing is complete
  // var tabDOM = tab.getPeer().getDomElement();
  var tabDOM = document.getElementById(tab.getClientId());

  // locating the tab anchor to position the dropdown
  var tabAnchor;
  if (tabDOM.nodeName == 'A')
    // case when nav pane has hint=buttons
    tabAnchor = tabDOM;
  else
    // case when nav pane has hint=tabs
    tabAnchor= tabDOM.getElementsByTagName('a')[0];

  // getDomElement() doesn't return anything 
  // until all Faces onload processing is complete
  // var launcherDOM = popupIconicLauncher.getPeer().getDomElement();
  var launcherDOM = document.getElementById(popupIconicLauncher.getClientId());

  // repositioning the dropdown after the tab anchor
  _wcDOMInsertAfter(tabAnchor, launcherDOM);
}

function _wcDOMInsertAfter(targetElement, newElement)
{
  var parent = targetElement.parentNode;
  if(parent.lastChild == targetElement)
    parent.appendChild(newElement);
  else
    parent.insertBefore(newElement, targetElement.nextSibling);
}

function wcActivateTabDropdownIcon(event)
{
  // keeping track of what tab the event was fired on
  var actionSource = event.getSource();
  _wcPrepareTabContext(actionSource);

  // activating and repositioning dropdown
  _wcActivateTabPopupLauncher(actionSource);
}

function wcOnClickTabDropdownIcon(event)
{
  var popupIconicLauncher = event.getSource();

  var tabClientId = popupIconicLauncher.getProperty('wcTabClientId');
  var tab = AdfPage.PAGE.findComponent(tabClientId);
  _wcPrepareTabContext(tab);

  var popup = popupIconicLauncher.findComponent('tabPopupActions');
  _wcShowTabPopup(popup, popupIconicLauncher);
}

function wcOnLeaveTabPane(event)
{
  var navPane = event.getSource();
  var popupIconLauncher = navPane.findComponent('tabPopUp:tabPopupLauncher');
  popupIconLauncher.setVisible(false);
}

/**
 * Displays the main context popup directly upon a right click of a tab.
 *
 * @param event Expected to be an event of type 'click' (in case of FF)
 *       or 'contextMenu' (in case of IE).
 */
function wcShowTabPopup(event)
{
    wcCloseTabTooltipPopup(event);
    // proceed only if event was not triggered by a left click 
    if (event.isLeftButtonPressed())
      return; 

    event.cancel();

    // keeping track of what tab the event was fired on
    var actionSource = event.getSource();
    _wcPrepareTabContext(actionSource);

    // launching the popup
    var navPane = actionSource.getParent();
    var popup = navPane.findComponent('tabPopUp:tabPopupActions');
    var popupIconLauncher = navPane.findComponent('tabPopUp:tabPopupLauncher');
    _wcShowTabPopup(popup, popupIconLauncher);
}

function _wcPrepareTabContext(actionSource)
{
    WCPopupLagData.TABCLIENTID = actionSource.getClientId();
    /*WCPopupLagData.TABALLOWEDOPS
      = actionSource.getProperty('wcAllowedOperations');
    // Not launching context menu if operations map not defined
    if (WCPopupLagData.TABALLOWEDOPS == null)
    //    WCPopupLagData.TABALLOWEDOPS[0] == null)
      return;*/

    WCPopupLagData.TAB_DESTINATION = actionSource.getProperty('tabDestination');
    WCPopupLagData.TAB_LABEL = actionSource.getProperty('tabLebel');
    WCPopupLagData.TAB_LEVEL = actionSource.getProperty('tabLevel');
    //var navPane = actionSource.getParent();
    //var hiddenInput = navPane.findComponent('tabPopUp:wcTabBarSelectedTabDestination');
    //hiddenInput.setValue(tabDestination);
}

function _wcShowTabPopup(popup, eventReceiver)
{
    AdfCustomEvent.queue(eventReceiver, "wcContextMenu", 
                         {tabDestination: WCPopupLagData.TAB_DESTINATION,
                          tabLevel:       WCPopupLagData.TAB_LEVEL}, 
                         true);

    var popupHints = {};
    popupHints[AdfRichPopup.HINT_ALIGN_ID] = WCPopupLagData.TABCLIENTID;
    popupHints[AdfRichPopup.HINT_ALIGN] = AdfRichPopup.ALIGN_AFTER_START;

    popup.show(popupHints);
}

/**
 * Called after the tab context popup is launched.
 *
 * <P>Responsible for hiding/showing menu items based on
 * what operations are allowed.
 *
 * @param event ADF Rich Client 'popup opened' event.
 */
function wcTabPopupOpened(event)
{
    // Getting hold of tab information

    var actionSource = AdfPage.PAGE.findComponent(WCPopupLagData.TABCLIENTID);
    var tabDestination = actionSource.getProperty('tabDestination');
    var allowedOperations = WCPopupLagData.TABALLOWEDOPS;

    var navPane = actionSource.getParent();

    // Manipulating values on context menu based on tab information

    var tabDestOnPopup = navPane.findComponent('tabPopUp:wcTabBarSelectedTabDestination');
    tabDestOnPopup.setValue(tabDestination);

    var closePrimaryTabAction = navPane.findComponent('tabPopUp:closePrimaryTabAction');
    if (closePrimaryTabAction != null)
      closePrimaryTabAction.setVisible(allowedOperations['CLOSE_PRIMARY_TAB'] == true);

    var closeOtherPrimaryTabsAction = navPane.findComponent('tabPopUp:closeOtherPrimaryTabsAction');
    if (closeOtherPrimaryTabsAction != null)
      closeOtherPrimaryTabsAction.setVisible(allowedOperations['CLOSE_OTHER_PRIMARY_TABS'] == true);

    var sendEmailToModerators = navPane.findComponent('tabPopUp:sendEmailToModerators');
    if (sendEmailToModerators != null)
      sendEmailToModerators.setVisible(allowedOperations['SEND_EMAIL_TO_MODERATORS'] == true);

    var showAboutGroupSpace = navPane.findComponent('tabPopUp:showAboutGroupSpace');
    if (showAboutGroupSpace != null)
      showAboutGroupSpace.setVisible(allowedOperations['SHOW_GROUP_SPACE_INFO'] == true);

    var hideTabAction = navPane.findComponent('tabPopUp:hideTabAction');
    if (hideTabAction != null)
      hideTabAction.setVisible(allowedOperations['HIDETAB'] == true);
    
    var addToPersonalAction = navPane.findComponent('tabPopUp:addToPersonalAction');
    if (addToPersonalAction != null)
      addToPersonalAction.setVisible(allowedOperations['ADDTOPERSONAL'] == true);

    var changeNameAction = navPane.findComponent('tabPopUp:changeNameAction');
    if (changeNameAction != null)
      changeNameAction.setVisible(allowedOperations['CHANGENAME'] == true);

    var addContentAction = navPane.findComponent('tabPopUp:addContentAction');
    if (addContentAction != null)
      addContentAction.setVisible(allowedOperations['ADDCONTENT'] == true);

    var pageSettingsAction = navPane.findComponent('tabPopUp:pageSettingsAction');
    if (pageSettingsAction != null)
      pageSettingsAction.setVisible(allowedOperations['PAGESETTINGS'] == true);

    var deletePageAction = navPane.findComponent('tabPopUp:deletePageAction');
    if (deletePageAction != null)
      deletePageAction.setVisible(allowedOperations['DELETEPAGE'] == true);
}


function wcShowAcceptTabRename(event) 
{ 
  var actionSource = event.getSource();

  // Initializing the text field with tab's current title
  var newTitleField = actionSource.findComponent('newTitleField');
  var tabInContext = AdfPage.PAGE.findComponent(WCPopupLagData.TABCLIENTID);
  newTitleField.setValue(tabInContext.getProperty('tabLabel'));

  // Now launching the popup
  var renamePopup = actionSource.findComponent('acceptTabRename');
  var popupHints = {};   
  popupHints[AdfRichPopup.HINT_ALIGN_ID] = WCPopupLagData.TABCLIENTID; 
  popupHints[AdfRichPopup.HINT_ALIGN] = AdfRichPopup.ALIGN_AFTER_START; 
  renamePopup.show(popupHints);
} 

function wcOpenTabTooltipPopup(event)
{
  var actionSource = event.getSource();
  var navPane = actionSource.getParent();
  var popup = navPane.findComponent('tabPopUp:tabTooltipPopup');  
  var popupHints = {};
  popupHints[AdfRichPopup.HINT_ALIGN_ID] = actionSource.getClientId();
  popupHints[AdfRichPopup.HINT_ALIGN] = AdfRichPopup.ALIGN_AFTER_START;

  if(popup==null || popup.isPopupVisible())
  {
    return;
  }

  event.cancel();
  showTabTooltip = true;

  function wcShowTabTooltipPopup()
  {
    if(showTabTooltip)
      popup.show(popupHints);
  }
  tabTooltipTimeoutId = setTimeout(wcShowTabTooltipPopup, 2000);
}

function wcCloseTabTooltipPopup(event)
{
  showTabTooltip = false;
  clearTimeout(tabTooltipTimeoutId);
}

